Bug 101034 - Web Bluetooth API
Summary: Web Bluetooth API
Status: RESOLVED WONTFIX
Alias: None
Product: WebKit
Classification: Unclassified
Component: WebCore Misc. (show other bugs)
Version: 528+ (Nightly build)
Hardware: All All
: P1 Major
Assignee: Nobody
URL: https://webbluetoothcg.github.io/web-...
Keywords:
Depends on:
Blocks: 101162
  Show dependency treegraph
 
Reported: 2012-11-02 02:53 PDT by Binyamin
Modified: 2019-11-21 23:01 PST (History)
22 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Comment 1 Binyamin 2012-11-02 02:59:28 PDT
Bluetooth Implementation on B2G https://bugzilla.mozilla.org/show_bug.cgi?id=727618
Comment 2 Alexey Proskuryakov 2012-11-02 10:49:10 PDT
Are you going to work on adding this to WebKit? Please e-mail webkit-dev for discussion then.

I would personally strongly oppose to adding this feature to WebKit.
Comment 3 Binyamin 2012-11-03 15:03:31 PDT
@Alexey, Web browsers must fallow the Web Standards and feature implementation time estimations.

As you can see Bluetooth API, Network Interface API, etc. has already LC, CR status http://www.w3.org/2012/09/sysapps-wg-charter.html

Discovery API must deliver also Bluetooth API access http://dev.webinos.org/specifications/draft/servicediscovery.html

> http://www.w3.org/QA/2011/10/web_applications_discovering_a.html
> There is no reason to limit web applications to accessing services over WiFi, as there are many services that are either exposed directly by a device, or indirectly via USB, Firewire (IEEE 1394), Bluetooth or other interconnect technologies such as ZigBee (for sensors) and NFC. A proof of concept was developed in early 2011 as a browser plugin for mDNS, SSDP, SLP, USB and Bluetooth. This suggests that a W3C discovery and binding API should work with a range of interconnect technologies and discovery techniques.


More resources:
http://www.w3.org/2009/dap/
http://www.w3.org/Mobile/mobile-web-app-state/
http://www.w3.org/2011/04/discovery.html
Comment 5 Michael[tm] Smith 2015-04-12 18:16:20 PDT
From the W3C Web Bluetooth Community Group there is now a standard spec for this at https://webbluetoothcg.github.io/web-bluetooth/ and I believe it's already landed in Gecko in https://bugzilla.mozilla.org/show_bug.cgi?id=1005848 and also there's work in progress on a Blink implementation https://www.chromestatus.com/features/5264933985976320
Comment 6 Julien Racle 2016-07-22 07:06:45 PDT
Please consider seriously web-bluetooth API. This is a step forward in unleashing IOT power, and many companies (including mine, Logitech) are looking for it eagerly!

Would be pleased to participate.
Comment 7 Gordon Williams 2016-08-22 06:52:57 PDT
Just to add my support for this as well. I develop Puck.js, and allowing web developers to control hardware in the real world straight from a webpage is going to lead to some amazing things being created.

Being able to write one web application and have it run on a variety of devices is going to mean a much cleaner, less buggy, better maintained experience for everyone. Not all hardware manufacturers can afford to develop and maintain apps for all the major platforms.

Unfortunately right now the only usable implementations seem to be very Google-centric. Getting decent platform support, specifically iOS, is going to be a huge help.
Comment 8 Bryce Watson 2017-05-24 17:36:38 PDT
Adding my support for this as well. I'm currently working on a product that uses physical web url notifications. These notifications work out of the box for most Android devices, but on iOS users are forced to download chrome to get this functionality.

Please consider adding support for physical web beacon notifications via Safari!
Comment 9 Gordon Williams 2017-05-25 00:32:57 PDT
Since my last post I ended up paying for an app to be made that implements (a reasonable subset of) Web Bluetooth on iOS, so that iOS users can at least use my hardware: https://itunes.apple.com/us/app/webble/id1193531073

However obviously it would be hugely preferable if the functionality came pre-installed (while Chrome on iOS supports Physical Web, it doesn't support Web Bluetooth)
Comment 10 Jonathan Ruiz 2017-09-27 01:35:45 PDT
This technology is a must for Progressive Web Applications and IoT.

Is this the best place to get updatse about it's implementation in webkit? 
Is there any plan to implement it in the future?
Comment 11 Martin Woolley 2017-10-16 03:56:23 PDT
Hello, I work for the Bluetooth SIG. 

I'm interested in the potential which a W3C standard Bluetooth LE API for browsers offers, though I not also some of the concerns raised by others. I'd welcome seeing work actively underway between the various parties to see if issues can be satisfactorily addressed. Bluetooth LE APIs are in most other platforms, including the various smartphone platforms. Bluetooth is going to be used increasingly in enterprise computing scenarios and as such, cloud technology with web applications rather than native desktop applications is likely to be the preferred architecture.

Aside from expressing our support, is there anything more tangible which the Bluetooth SIG might be able to contribute? I'd be happy to discuss by phone or face to face.

Thanks

Martin
Comment 12 buche2 2019-08-13 09:06:46 PDT
Hello together
The standard of the Web Bluetooth Api is now very advanced. Is it already known from your side: whether and until when you implement this?
Comment 13 Alexey Proskuryakov 2019-08-13 09:11:26 PDT
Please see the feature status page: https://webkit.org/status/#?search=bluetooth
Comment 14 buche2 2019-08-13 09:16:59 PDT
Thanks for your fast request. But why its not considering?
Comment 15 Sanjay Kumar 2019-08-29 13:23:30 PDT
Please consider this. This helps connect Bluetooth IoT devices to mobile Safari - we need this.
Comment 16 Tom Colvin 2019-11-20 03:35:25 PST
Hello,
Good to see some big voices adding their support to this. I don't understand why it's not in consideration. I'm the CTO of an app design agency and would love to be able to provide support for connecting to Bluetooth devices via progressive web apps. At the moment the only way of using Bluetooth cross-platform is via a native app.
I honestly don't see any reason why we wouldn't want to support this. Other engines do - meaning support is present in Chrome non-iOS, Opera, Samsung. Perhaps I'm missing something - but where's the debate?
- Tom
Comment 17 Tom Colvin 2019-11-20 03:36:12 PST
(In reply to buche2 from comment #14)
> Thanks for your fast request. But why its not considering?

Yes, indeed.
Comment 18 Michael Catanzaro 2019-11-20 06:02:04 PST
This web API proposal is not under consideration, so there's no point in leaving this bug open. Closing.

Proposals for new web APIs are welcome on webkit-devel@
Comment 19 Binyamin 2019-11-20 06:34:51 PST
FYI Web Bluetooth API has been implemented in Chrome https://www.chromestatus.com/feature/5264933985976320, leaving Safari behind. You can use Chrome on macOS.

Spec https://webbluetoothcg.github.io/web-bluetooth/
Comment 20 Vincent Scheib 2019-11-20 16:27:35 PST
Howdy Michael, 

What is the current suggested way for Web Developers to express interest in features for WebKit?  I haven't contributed to WebKit for a few years, and don't recognize your suggestion below for webkit-devel@; Should that be webkit-dev email list?  I couldn't find webkit-devel mentioned on webkit.org.
Comment 21 Michael Catanzaro 2019-11-21 07:47:02 PST
Er yes, I meant webkit-dev@. (I don't think we have a separate list for web developers or any other place to ask questions like this.)

Since web bluetooth is a controversial spec, I would suggest phrasing your message as a question as to why it's not under consideration.
Comment 22 Martin Woolley 2019-11-21 07:52:44 PST
(In reply to Michael Catanzaro from comment #21)
> Er yes, I meant webkit-dev@. (I don't think we have a separate list for web
> developers or any other place to ask questions like this.)
> 
> Since web bluetooth is a controversial spec, I would suggest phrasing your
> message as a question as to why it's not under consideration.

What exactly is the controversy? Perhaps if the issues were out in the open, they could be addressed?
Comment 23 Julien Racle 2019-11-21 08:03:14 PST
I hope the controversy is not about breaking business model (app store) and is more about security.

If this is the latter, please don't disregard it and express your concerns.

Alexey Proskuryakov said some time ago he personally opposed, but why oh why??

FYI also API is shipped in Edge, which is now based on blink
Comment 24 Gordon Williams 2019-11-21 09:21:37 PST
I'd just like to re-add my support for Web Bluetooth. I have thousands of users running Espruino on Web Bluetooth browsers with Espruino, and right now it's ridiculous that they can only get it to work on iOS via the WebBLE app.

I'd be extremely interested in hearing any security concerns too. Web Bluetooth has been in Chrome for 3 years and I haven't heard of a single security issue.

So am I right in saying that now, rather than expressing our support in one place, we should all just spam the webkit-dev mailing list?
Comment 25 Michael Catanzaro 2019-11-21 13:01:17 PST
I certainly don't suggest spamming the mailing list, but I think if you were to send a mail to ask why this feature is not being considered, you would very likely receive an informed answer as to why this feature is not under consideration for implementation in WebKit. I think you're not very likely to get an answer here. Bugzilla is not a great place for spec implementation requests.
Comment 26 Martin Woolley 2019-11-21 23:01:46 PST
(In reply to Michael Catanzaro from comment #25)
> I certainly don't suggest spamming the mailing list, but I think if you were
> to send a mail to ask why this feature is not being considered, you would
> very likely receive an informed answer as to why this feature is not under
> consideration for implementation in WebKit. I think you're not very likely
> to get an answer here. Bugzilla is not a great place for spec implementation
> requests.

Thanks for the advice, Michael.

For other readers of this issue report, it's also worth pointing out that Bluetooth today is very different to the Bluetooth of 20 years ago. Maybe an update on the current state of play would be useful if this request is reissued? I'd be happy to help.

Martin Woolley
Bluetooth SIG